GameTooltip.PQOverride_SetQuestItem = GameTooltip.SetQuestItem;

PlayerQuest.items.itemLink = nil;

function PLQ_P_SET_REAL_LINK(lnk)
	PlayerQuest.items.itemLink = lnk;
	return "|H"..lnk.."|h";
end

function PlayerQuest.items.GetActualLink(link)
	string.gsub(link, "|H(.*)|h", PLQ_P_SET_REAL_LINK);
	
	--PlayerQuest.OutputMessage(link.." : "..PlayerQuest.items.itemLink);
	
	return PlayerQuest.items.itemLink
end

function GameTooltip.SetQuestItem(gttp, type, index)
	if(PlayerQuest.inter.Intermediate) then
		--PQ_OutputMessage("Index: "..index);
		--PQ_OutputMessage("Translated: "..PQ_GetRewardItem(index));
		if(PlayerQuest.inter.Intermediate.rewards[PlayerQuest.inter.GetRewardItem(index)].type=="promotion") then
			-- do something eventually...
			return
		elseif(PlayerQuest.inter.Intermediate.rewards[PlayerQuest.inter.GetRewardItem(index)].type=="item") then
			gttp:SetHyperlink(PlayerQuest.items.GetActualLink(PlayerQuest.inter.Intermediate.rewards[PlayerQuest.inter.GetRewardItem(index)].link));
			return;
		end
	end
	
	return gttp:PQOverride_SetQuestItem(type, index);
end;

GameTooltip.PQOverride_SetQuestLogItem = GameTooltip.SetQuestLogItem;

function GameTooltip.SetQuestLogItem(gttp, type, index)
	if(PlayerQuest.Ready()) then
		if(PlayerQuest.questlog.Selection > 0) then
			local pdata = PlayerQuest.PlayerData();
			if(pdata.quests[PlayerQuest.questlog.Selection].rewards[PlayerQuest.questlog.GetLogRewardID(index)].type=="promotion") then
				-- do something eventually...
				return
			
			elseif(pdata.quests[PlayerQuest.questlog.Selection].rewards[PlayerQuest.questlog.GetLogRewardID(index)].type=="item") then
				gttp:SetHyperlink(PlayerQuest.items.GetActualLink(pdata.quests[PlayerQuest.questlog.Selection].rewards[PlayerQuest.questlog.GetLogRewardID(index)].link));
				return;
			end
		end
	end
	
	return gttp:PQOverride_SetQuestLogItem(type, index);
end;

PQ_NUM_REW_TYPES = 4 --[[ 5 ]] ;

PQ_Rew_Types = { ["money"]=1, 
			["item"]=2, 
			["item_choice"]=3,
			["promotion"]=4 --[[,
			["reputation"]=5 ]]
			};

PQ_Rew_Type_Frame = { [0] = "PQ_SELECT_TYPE_FRAME",
			"PQ_MISC_TYPE_FRAME",
			"PQ_MISC_TYPE_FRAME",
			"PQ_MISC_TYPE_FRAME",
			"PQ_NOSETTINGS_TYPE_FRAME",
			"PQ_MISC_TYPE_FRAME"
			};
			
PQ_Rew_Type_Init = {};

PQ_Rew_Type_Init[1] = function ()
	MF_ItemBox:Hide();
	MF_OP_Frame:Hide();
	PQ_MF_LBL1:Hide();
	MF_1Text:Hide();
	MF_1_TextBox:Hide();

	PQ_MF_LBL2:SetText(PQ_AMOUNT);
end

PQ_Rew_Type_Init[2] = function ()
	MF_ItemBox:Show();
	PQ_MF_LBL1:Hide();
	MF_1Text:Hide();
	MF_1_TextBox:Hide();
	MF_OP_Frame:Hide();
	
	PQ_MF_LBL2:SetText(PQ_COUNT);
	
	MF_2_TextBox:SetText("");
	PQ_MF_ILBL1:SetText("<No Item>");
	MF_ItemBox_BoxIcon:SetTexture(GetInventorySlotInfo("Trinket0Slot"));
end

PQ_Rew_Type_Init[3] = function ()
	MF_ItemBox:Show();
	PQ_MF_LBL1:Hide();
	MF_1Text:Hide();
	MF_1_TextBox:Hide();
	MF_OP_Frame:Hide();
	
	PQ_MF_LBL2:SetText(PQ_COUNT);
	
	MF_2_TextBox:SetText("");
	PQ_MF_ILBL1:SetText("<No Item>");
	MF_ItemBox_BoxIcon:SetTexture(GetInventorySlotInfo("Trinket0Slot"));
end

--[[ PQ_Rew_Type_Init[5] = function ()
	MF_ItemBox:Hide();
	MF_OP_Frame:Hide();
	PQ_MF_LBL1:Hide();
	MF_1Text:Hide();
	MF_1_TextBox:Hide();

	PQ_MF_LBL2:SetText(PQ_REPAMOUNT);
end ]]

PQ_Rew_Type_LoadFunc = {};

PQ_Rew_Type_LoadFunc[1] = function ( rid )
	MF_2_TextBox:SetText(""..PlayerQuest.wizard.Working.rewardMoney);
end

PQ_Rew_Type_LoadFunc[2] = function ( rid )
	MF_2_TextBox:SetText(PlayerQuest.wizard.Working.rewards[rid].numItems);
	PQ_MF_ILBL1:SetText(PlayerQuest.wizard.Working.rewards[rid].name);
	MF_ItemBox_BoxIcon:SetTexture(PlayerQuest.wizard.Working.rewards[rid].texture);
	
	PlayerQuest.items.CurrentItem  = {};

	PlayerQuest.items.CurrentItem.name = PlayerQuest.wizard.Working.rewards[rid].name;
	PlayerQuest.items.CurrentItem.link = PlayerQuest.wizard.Working.rewards[rid].link;
	PlayerQuest.items.CurrentItem.texture = PlayerQuest.wizard.Working.rewards[rid].texture;
	PlayerQuest.items.CurrentItem.quality = 1;
	PlayerQuest.items.CurrentItem.isUseable = 1;
end

PQ_Rew_Type_LoadFunc[5] = function ( rid )
	MF_2_TextBox:SetText(""..PlayerQuest.wizard.Working.rewards[rid].numItems);
end

PQ_Rew_Type_SaveFunc = {};

PQ_Rew_Type_SaveFunc[0] = function ( rid )
	PlayerQuest.wizard.Working.rewards[rid] = nil;
end;

PQ_Rew_Type_SaveFunc[1] = function ( rid )
	PlayerQuest.wizard.Working.rewards[rid] = {};

	PlayerQuest.wizard.Working.rewards[rid].type = "money";
	
	PlayerQuest.wizard.Working.rewardMoney = tonumber(MF_2_TextBox:GetText());
end

PQ_Rew_Type_SaveFunc[2] = function ( rid )
	PlayerQuest.wizard.Working.rewards[rid] = {};

	PlayerQuest.wizard.Working.rewards[rid].type = "item";
	PlayerQuest.wizard.Working.rewards[rid].name = PlayerQuest.items.CurrentItem.name;
	PlayerQuest.wizard.Working.rewards[rid].link = PlayerQuest.items.CurrentItem.link;
	PlayerQuest.wizard.Working.rewards[rid].texture = PlayerQuest.items.CurrentItem.texture;
	PlayerQuest.wizard.Working.rewards[rid].numItems = PlayerQuest.tonumber(MF_2_TextBox:GetText());
	PlayerQuest.wizard.Working.rewards[rid].quality = 1;
	PlayerQuest.wizard.Working.rewards[rid].isUseable = 1;
end

PQ_Rew_Type_SaveFunc[4] = function ( rid )
	PlayerQuest.wizard.Working.rewards[rid] = {};

	PlayerQuest.wizard.Working.rewards[rid].type = "promotion";
	PlayerQuest.wizard.Working.rewards[rid].texture = "Interface\\Icons\\INV_Misc_Note_02";
	PlayerQuest.wizard.Working.rewards[rid].name = "Guild Promotion";
	PlayerQuest.wizard.Working.rewards[rid].link = nil;
	PlayerQuest.wizard.Working.rewards[rid].numItems = 0;
	PlayerQuest.wizard.Working.rewards[rid].quality = 1;
	PlayerQuest.wizard.Working.rewards[rid].isUseable = 1;
	
	PlayerQuest.wizard.Working.rewardMoney = tonumber(MF_2_TextBox:GetText());
end

--[[ PQ_Rew_Type_SaveFunc[5] = function ( rid )
	PlayerQuest.wizard.Working.rewards[rid] = {};
	
	PlayerQuest.wizard.Working.rewards[rid].type = "reputation";
	PlayerQuest.wizard.Working.rewards[rid].name = GetGuildInfo("player");
	PlayerQuest.wizard.Working.rewards[rid].numItems = tonumber(MF_2_TextBox:GetText()); 
end ]]

function PQ_Rew_Show_Type_Frame( id )
	for i = 0, PQ_NUM_REW_TYPES, 1 do
		if(i == id) then
			getglobal(PQ_Rew_Type_Frame[i]):Show();
		else
			if(PQ_Rew_Type_Frame[i] ~= PQ_Rew_Type_Frame[id]) then
				getglobal(PQ_Rew_Type_Frame[i]):Hide();
			end
		end
	end
	
	local func = PQ_Rew_Type_Init[id];
	if(func) then
		func();
	end;
end
			
function PQ_Rew_Print( id )
	local test;
	local rt = PQ_Rew_Types[PlayerQuest.wizard.Working.rewards[id].type];
	
	return PQ_Rew_Type_Show[rt](PlayerQuest.wizard.Working.rewards[id]);
end;
			
PQ_Rew_Type_Show = {};

PQ_Rew_Type_Show[1] = function (f)
	return "Get Money: "..PlayerQuest.wizard.Working.rewardMoney;
end;

PQ_Rew_Type_Show[2] = function (f)
	return "Get "..f.numItems.." "..f.name.."(s)";
end;

PQ_Rew_Type_Show[4] = function (f)
	return "Guild Promotion";
end;

-- PQ_Rew_Type_Show[5] = function (f)
--	return "Guild Reputation: "..f.numItems;
-- end;
