
--packages
PlayerQuest.comms = {};
PlayerQuest.comms.extract = {};
PlayerQuest.comms.ChunkList = {};

local pqcom = PlayerQuest.comms;

--functions

function PlayerQuest.comms.GetChannelNum()		
	return  GetChannelName(PQ_COMM_CHANNEL);
end;

PlayerQuest.comms.ChunkList = {};

function PlayerQuest.comms.Send(player, mtype, msg)
	--local cnum = GetChannelNumber("PlayerQuestComm");
	
	-- "fix up" the message ...
	msg = string.gsub(msg, "\n", "<br>");
	
	local fullmsg = mtype.."@"..player.."@"..msg;
	local fml = string.len(fullmsg);
	
	if(fml>250) then
		local pmsgind = 1;
		PlayerQuest.comms.Send(player, "MSG_CHUNKED_START", "Start");
		while(pmsgind < fml) do
			--send off 100 chars or the end of the string...
			local chunk;
			if(fml < (pmsgind+100)) then
				chunk = string.sub(fullmsg, pmsgind);
				pmsgind = fml;
			else
				chunk = string.sub(fullmsg, pmsgind, pmsgind+99);
				pmsgind = pmsgind + 100;
			end
			--PQ_OutputMessage("Message Chunk Index: "..pmsgind);
			--PQ_OutputMessage("Chunk Length: "..string.len(chunk));
			
			PlayerQuest.comms.Send(player, "MSG_CHUNKED_SEND", chunk);
		end
		PlayerQuest.comms.Send(player, "MSG_CHUNKED_END", "End");
		return;
	end;
	
	SendChatMessage(fullmsg,"CHANNEL",nil,PlayerQuest.comms.GetChannelNum());
	--PQ_OutputMessage("Message Sent: "..player..", "..mtype..", "..msg);
end;

function PlayerQuest.comms.CheckMsg(msg, fplayer)
	local idx = string.find(msg, "@");
	if(not idx) then
		return nil;
	end;
	local mtype = string.sub(msg, 1,idx-1);
	local ends = string.sub(msg, idx+1);
	
	idx = string.find(ends, "@");
	if(not idx) then
		return nil;
	end;
	local player = string.sub(ends, 1, idx-1);
	local mess = string.sub(ends, idx+1);
	
	--PQ_OutputMessage("Monitored Message: "..player..", "..mtype..", "..mess);
	if(PlayerQuest.ShortPlayerName == player) then
		PlayerQuest.comms.ProcessMessage(fplayer, mtype, mess);
	end;
	return 1;
end;

function PlayerQuest.comms.FindQuests(fplayer)
	local qlist = {};
	local count = 0;
	local pdata = PlayerQuest.PlayerData();
	for i = 1, pdata.nCreatedQuests, 1 do
		local found = nil;
		for j = 1, pdata.createdQuests[i].nRestricts, 1 do
			local restrict = pdata.createdQuests[i].restricts[j];
			if(restrict.type == "player_name") then
				if(restrict.name ~= fplayer.name) then
					found = 1;
				end
			end
			if(restrict.type == "player_class") then
				if(restrict.name ~= fplayer.class) then
					found = 1;
				end
			end
			if(restrict.type == "player_race") then
				if(restrict.name ~= fplayer.race) then
					found = 1;
				end
			end
			if(restrict.type == "player_guild") then
				if(restrict.name ~= fplayer.guild) then
					found = 1;
				end
			end
			if(restrict.type == "player_level") then
				if((restrict.minLevel >= fplayer.level) and (fplayer.level ~= -1)) then
					found = 1;
				end
			end
			if(restrict.type == "player_level_max") then
				if((restrict.maxLevel <= fplayer.level) and (fplayer.level ~= -1)) then
					found = 1;
				end
			end
		end
		if(not found) then
			count = count + 1;
			qlist[count] = i;
		end
	end; 
	return count, qlist;
end;

function PlayerQuest.comms.GetGreetingText()
	return "Greetings fellow PlayerQuester! This text will soon be configurable.  Thanks for participating in the Alpha tests.  Please submit any bugs to the forums on www.playerquest.org.";
end;

function PlayerQuest.comms.FindQuest(qn, player)
	local n, qlist = PlayerQuest.comms.FindQuests(player);
	local pdata = PlayerQuest.PlayerData();
	for ql=1, n, 1 do
		local wquest = pdata.createdQuests[qlist[ql]];
		if(wquest.titleText == qn) then
			return qlist[ql];
		end
	end
	
	return nil;
end

function PlayerQuest.comms.Extract(line, pos)
	local ret;
	local pqext = PlayerQuest.comms.extract;
	if(pos == nil) then
		pqext.cmsg = line;
		pqext.ind = string.find(pqext.cmsg, "@");
		ret = string.sub(pqext.cmsg, 1, pqext.ind-1);
		pqext.cmsg = string.sub(pqext.cmsg, pqext.ind+1);
	elseif(pos == 1) then
		pqext.ind = string.find(pqext.cmsg, "@");
		ret = string.sub(pqext.cmsg, 1, pqext.ind-1);
		pqext.cmsg = string.sub(pqext.cmsg, pqext.ind+1);
	else
		ret = pqext.cmsg
	end
	
	--PQ_OutputMessage("split off: "..ret);
	return ret;
end

function PlayerQuest.comms.SafeString(x)
	if(x) then
		return x;
	else
		return "";
	end
end

function PlayerQuest.comms.ProcessMessage(fplayer, mtype, msg)
--	PQ_OutputMessage("Message: "..fplayer..", "..mtype..", "..msg);
	
	-- "fix up" the message ...
	msg = string.gsub(msg, "<br>", "\n");
	
	local pdata = PlayerQuest.PlayerData();

	if(mtype == "MSG_PRECACHE_START") then
		-- Output all relavent quests.......
		local play_info = {};
		--TargetByName(fplayer);
		--if(UnitName("target") ~= fplayer) then
		--	return
		--end;
		
		play_info.name = fplayer;
		play_info.class = PlayerQuest.comms.Extract(msg); --UnitClass("target");
		play_info.race = PlayerQuest.comms.Extract(msg, 1);
		play_info.level = tonumber(PlayerQuest.comms.Extract(msg, 1));
		play_info.guild = PlayerQuest.comms.Extract(msg, 2);
		
		local n, qlist = PlayerQuest.comms.FindQuests(play_info);
		if(n == 0) then
			return;
		end
		PlayerQuest.comms.Send(fplayer, "MSG_PRECACHE_CONFIRM", "Confirm");
		PlayerQuest.comms.Send(fplayer, "MSG_NUM_AVAILABLE_QUESTS", format("%d", n));
		PlayerQuest.comms.Send(fplayer, "MSG_GREETING", PlayerQuest.AliasReplace(PlayerQuest.comms.GetGreetingText(fplayer), play_info.name, play_info.class, play_info.race, play_info.guild));
		for i=1, n, 1 do
			PlayerQuest.comms.Send(fplayer, "MSG_QUEST", pdata.createdQuests[qlist[i]].titleText);
			PlayerQuest.comms.Send(fplayer, "MSG_QUEST_DESCRIPTION", PlayerQuest.AliasReplace(pdata.createdQuests[qlist[i]].Description, play_info.name, play_info.class, play_info.race, play_info.guild));
			PlayerQuest.comms.Send(fplayer, "MSG_QUEST_OBJECTIVE_TEXT", PlayerQuest.AliasReplace(pdata.createdQuests[qlist[i]].Objectives, play_info.name, play_info.class, play_info.race, play_info.guild));
			PlayerQuest.comms.Send(fplayer, "MSG_QUEST_PROGRESS_TEXT", PlayerQuest.AliasReplace(pdata.createdQuests[qlist[i]].ProgressText, play_info.name, play_info.class, play_info.race, play_info.guild));
			PlayerQuest.comms.Send(fplayer, "MSG_QUEST_COMPLETE_TEXT", PlayerQuest.AliasReplace(pdata.createdQuests[qlist[i]].CompleteText, play_info.name, play_info.class, play_info.race, play_info.guild));
			local a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
			a1 = pdata.createdQuests[qlist[i]].level;
			if(a1 == nil) then
				a1 = 0;
			end;
			a2 = pdata.createdQuests[qlist[i]].requiredMoney;
			if(a2 == nil) then
				a2 = 0;
			end;
			a3 = pdata.createdQuests[qlist[i]].rewardMoney;
			if(a3 == nil) then
				a3 = 0;
			end;
			a4 = pdata.createdQuests[qlist[i]].nChoices;
			if(a4 == nil) then
				a4 = 0;
			end;
			a5 = pdata.createdQuests[qlist[i]].nRewards;
			if(a5 == nil) then
				a5 = 0;
			end;
			a6 = pdata.createdQuests[qlist[i]].nFinishPlayers;
			if(a6 == nil) then
				a6 = 0;
			end;
			a7 = pdata.createdQuests[qlist[i]].nLeaderBoards;
			if(a7 == nil) then
				a7 = 0;
			end;
			a8 = pdata.createdQuests[qlist[i]].nRequired;
			if(a8 == nil) then
				a8 = 0;
			end;
			a9 = pdata.createdQuests[qlist[i]].nFailureConditions;
			if(a9 == nil) then
				a9 = 0;
			end;
			--a10 = pdata.createdQuests[qlist[i]].timeLeft;
			--if(a10 == nil) then
			--	a10 = 0;
			--end;
			
			PlayerQuest.comms.Send(fplayer, "MSG_QUEST_NUMBERS", a1.."@"..a2.."@"..a3.."@"..a4.."@"..a5.."@"..a6.."@"..a7.."@"..a8.."@"..a9);
			if(pdata.createdQuests[qlist[i]].guildRep) then
				PlayerQuest.comms.Send(fplayer, "MSG_QUEST_REPINFO", pdata.createdQuests[qlist[i]].guildRep.."@"..pdata.createdQuests[qlist[i]].guildRepIncrease);
			end;
			
			if(pdata.createdQuests[qlist[i]].hasTimer) then
				PlayerQuest.comms.Send(fplayer, "MSG_QUEST_TIMERINFO", pdata.createdQuests[qlist[i]].hasTimer.."@"..pdata.createdQuests[qlist[i]].timeLeft);
			end;
			
			--send the requirements/leaderboards...--
			for j=1, pdata.createdQuests[qlist[i]].nRequired, 1 do
				local rtype, name, tim, ll, lh, ltype, count, text, a;
				a = pdata.createdQuests[qlist[i]].required[j].type;
				if(a == nil) then
					rtype = "";
				else
					rtype = a;
				end;
				a = pdata.createdQuests[qlist[i]].required[j].name;
				if(a == nil) then
					name = "";
				else
					name = a;
				end;
				a = pdata.createdQuests[qlist[i]].required[j].fullTime;
				if(a == nil) then
					tim = 0;
				else
					tim = a;
				end;
				a = pdata.createdQuests[qlist[i]].required[j].levelRangeLow;
				if(a == nil) then
					ll = 0;
				else
					ll = a;
				end;
				a = pdata.createdQuests[qlist[i]].required[j].levelRangeHigh;
				if(a == nil) then
					lh = 0;
				else
					lh = a;
				end;
				a = pdata.createdQuests[qlist[i]].leaderBoards[j].ptype;
				if(a == nil) then
					ltype = "";
				else
					ltype = a;
				end;
				a = pdata.createdQuests[qlist[i]].leaderBoards[j].countMax;
				if(a == nil) then
					count = 0;
				else
					count = a;
				end;
				a = pdata.createdQuests[qlist[i]].leaderBoards[j].text;
				if(a == nil) then
					text = "";
				else
					text = a;
				end;
				
				local ilink, itexture;
				
				ilink = string.gsub(PlayerQuest.comms.SafeString(pdata.createdQuests[qlist[i]].required[j].link), "|", "*");
				itexture = PlayerQuest.comms.SafeString(pdata.createdQuests[qlist[i]].required[j].texture);

				PlayerQuest.comms.Send(fplayer, "MSG_REQ", rtype.."@"..name.."@"..tim.."@"..ll.."@"..lh.."@"..ltype.."@"..count.."@"..text.."@"..ilink.."@"..itexture);
				--PQ_OutputMessage("MSG_REQ", rtype.."@"..name.."@"..tim.."@"..ll.."@"..lh.."@"..ltype.."@"..count.."@"..text.."@"..ilink.."@"..itexture);
			end
			
			-- send the rewards...
			for j=1, pdata.createdQuests[qlist[i]].nRewards, 1 do
				local theQuest = pdata.createdQuests[qlist[i]];
				local tex, name, nItems, qual, isUse, link = "", "", 0, 0, "", "";
				
				if(theQuest.rewards[j].texture) then
					tex = theQuest.rewards[j].texture;
				end
				if(theQuest.rewards[j].name) then
					name = theQuest.rewards[j].name;
				end
				if(theQuest.rewards[j].numItems) then
					nItems = theQuest.rewards[j].numItems;
				end
				if(theQuest.rewards[j].quality) then
					qual = theQuest.rewards[j].quality;
				end
				if(theQuest.rewards[j].isUseable) then
					isUse = theQuest.rewards[j].isUseable;
				end
				if(theQuest.rewards[j].link) then
					link = string.gsub(theQuest.rewards[j].link, "|", "*");
				end

				PlayerQuest.comms.Send(fplayer, "MSG_REWARD", pdata.createdQuests[qlist[i]].rewards[j].type.."@"..tex.."@"..name.."@"..nItems.."@"..qual.."@"..isUse.."@"..link);
			end;
			
			for j=1, pdata.createdQuests[qlist[i]].nFailureConditions, 1 do
				local theQuest = pdata.createdQuests[qlist[i]];
				local ftype = "";
				
				if(theQuest.failureConditions[j].type) then
					ftype = theQuest.failureConditions[j].type;
				end

				PlayerQuest.comms.Send(fplayer, "MSG_FAIL", ftype);
			end;

						-- send the finish players... (right now just one) --
			for j=1, pdata.createdQuests[qlist[i]].nFinishPlayers, 1 do
				PlayerQuest.comms.Send(fplayer, "MSG_FPLAYER", pdata.createdQuests[qlist[i]].finishPlayers[j]);
			end
			
			-- send the rewards/choices...
			-- send all the quest data....
		end
		PlayerQuest.comms.Send(fplayer, "MSG_PRECACHE_FINISHED", "Done");
	elseif(mtype == "MSG_CHECK_QUESTS") then
		local play_info = {};
		--TargetByName(fplayer);
		--if(UnitName("target") ~= fplayer) then
		--	return
		--end;
		
		play_info.name = fplayer;
		play_info.class = PlayerQuest.comms.Extract(msg); --UnitClass("target");
		play_info.race = PlayerQuest.comms.Extract(msg, 1);
		play_info.level = tonumber(PlayerQuest.comms.Extract(msg, 1));
		play_info.guild = PlayerQuest.comms.Extract(msg, 2);
		
		local n, qlist = PlayerQuest.comms.FindQuests(play_info);
		PlayerQuest.comms.Send(fplayer, "MSG_QUESTS_AVAIL", ""..n);
--[[	elseif(mtype == "MSG_SET_REP_WITH_ME") then
		local amount = PlayerQuest.comms.Extract(msg);
		local faction = PlayerQuest.comms.Extract(msg,2);
		PlayerQuest.reputation.SetRep(faction, fplayer, amount);
		PlayerQuest.reputation.UpdateLastRep(fplayer, faction);
	elseif(mtype == "MSG_UPDATE_STORED_REP") then
		PlayerQuest.reputation.SetLastRep(fplayer, PlayerQuest.tonumber(msg)); ]]
	elseif(mtype == "MSG_COMPLETE") then
		--check for emote and guild rewards
		local play_info = {};
		TargetByName(fplayer);
		if(UnitName("target") ~= fplayer) then
			return
		end;

		play_info.name = fplayer;
		play_info.class = UnitClass("target");
		play_info.race = UnitRace("target");
		play_info.level = UnitLevel("target");
		play_info.guild = GetGuildInfo("target");

		local qi = PlayerQuest.comms.FindQuest(msg, play_info);
		local cquest = pdata.createdQuests[qi];
		local tradeopened = nil
		for eg=1, cquest.nRewards, 1 do
		--[[	if(cquest.rewards[eg].type == "reputation") then
				PlayerQuest.reputation.AddLocalRep(cquest.rewards[eg].name, cquest.rewards[eg].numItems)
				--UpdateLocalRep(fplayer);
			else ]] if(cquest.rewards[eg].type == "promotion") then
				if(fplayer ~= PQ_ShortPlayerName) then
					GuildPromoteByName(fplayer);
				end
				--eg = cquest.nRewards
			elseif(cquest.rewards[eg].type == "item") then
				if(not tradeopened) then
					if(PlayerQuest.ShortPlayerName == UnitName("target")) then
						--PlayerQuest.OutputMessage("<No trading with yourself>");
					else
						InitiateTrade("target");
					end
					tradeopened = 1;
				end
				-- add an item...
					if(PlayerQuest.ShortPlayerName == UnitName("target")) then
						--PlayerQuest.OutputMessage("-- Would be trading : "..cquest.rewards[eg].numItems.." ".. cquest.rewards[eg].name.."(s)");
					else
						-- PlayerQuest.items.PickupThis(cquest.rewards[eg].link, cquest.rewards[eg].numItems);
					end
				
			end
		end
		
		PlayerQuest.CompMessage(fplayer.." has completed "..cquest.titleText);
	elseif(mtype == "MSG_QUESTS_AVAIL") then
		local n = tonumber(msg);
		if(n==0) then
			PQTBadge1:Hide();
			PQTBadge2:Show();
		else
			PQTBadge1:Show();
			PQTBadge2:Hide();
		end
	elseif(mtype == "MSG_ACCEPT_QUEST") then
		PlayerQuest.OutputMessage(fplayer.." has accepted the quest ("..msg..").");
	elseif(mtype == "MSG_DECLINE_QUEST") then
		PlayerQuest.OutputMessage(fplayer.." has declined the quest ("..msg..").");
	elseif(mtype == "MSG_PRECACHE_CONFIRM") then
		-- clear cached data
		PlayerQuest.comms.DataCache = nil;
		PlayerQuest.comms.CCQuest = 0
		
		PlayerQuest.comms.DataCache = {};
		PlayerQuest.comms.DataCache.player = fplayer;
		PlayerQuest.comms.DataCache.quests = {};
	elseif(mtype == "MSG_GREETING") then
		PlayerQuest.comms.DataCache.greetingText = msg;
	elseif(mtype == "MSG_NUM_AVAILABLE_QUESTS") then
		PlayerQuest.comms.DataCache.nQuests = tonumber(msg);
	elseif(mtype == "MSG_FPLAYER") then
		PlayerQuest.comms.FplayerC = PlayerQuest.comms.FplayerC + 1;
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].finishPlayers[PlayerQuest.comms.FplayerC] = msg;
	elseif(mtype == "MSG_QUEST") then
		PlayerQuest.comms.CCQuest=PlayerQuest.comms.CCQuest+1;
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest] = {};
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].titleText = msg;
		PlayerQuest.comms.FplayerC = 0;
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].finishPlayers = {};
	elseif(mtype == "MSG_QUEST_DESCRIPTION") then
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].Description = string.gsub(msg, "<br>", "\n");
	elseif(mtype == "MSG_QUEST_OBJECTIVE_TEXT") then
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].Objectives = string.gsub(msg, "<br>", "\n");
	elseif(mtype == "MSG_QUEST_PROGRESS_TEXT") then
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].ProgressText = string.gsub(msg, "<br>", "\n");
	elseif(mtype == "MSG_QUEST_COMPLETE_TEXT") then
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].CompleteText = string.gsub(msg, "<br>", "\n");
	elseif(mtype == "MSG_QUEST_NUMBERS") then
--		local parmList = string.split(msg, "@");

		local cmsg = msg;
		local ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].level = tonumber(string.sub(cmsg, 1, ind-1));
--		PlayerQuest.comms.OutputMessage("Split off :"..string.sub(cmsg, 1, ind-1));
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].requiredMoney = tonumber(string.sub(cmsg, 1, ind-1));
--		PlayerQuest.comms.OutputMessage("Split off :"..string.sub(cmsg, 1, ind-1));
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewardMoney = tonumber(string.sub(cmsg, 1, ind-1));
--		PlayerQuest.comms.OutputMessage("Split off :"..string.sub(cmsg, 1, ind-1));
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].nChoices = tonumber(string.sub(cmsg, 1, ind-1));
--		PlayerQuest.comms.OutputMessage("Split off :"..string.sub(cmsg, 1, ind-1));
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].nRewards = tonumber(string.sub(cmsg, 1, ind-1));
--		PlayerQuest.comms.OutputMessage("Split off :"..string.sub(cmsg, 1, ind-1));
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].nFinishPlayers = tonumber(string.sub(cmsg, 1, ind-1));
--		PlayerQuest.comms.OutputMessage("Split off :"..string.sub(cmsg, 1, ind-1));
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].nLeaderBoards = tonumber(string.sub(cmsg, 1, ind-1));
--		PlayerQuest.comms.OutputMessage("nLB :"..string.sub(cmsg, 1, ind-1));
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].nRequired = tonumber(string.sub(cmsg, 1, ind-1));

--		cmsg = string.sub(cmsg, ind+1);
--		ind = string.find(cmsg, "@");
--		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].nFailureConditions = tonumber(string.sub(cmsg, 1, ind-1));

		cmsg = string.sub(cmsg, ind+1);
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].nFailureConditions = tonumber(cmsg);
--		PlayerQuest.comms.OutputMessage("nR :"..cmsg);
		PlayerQuest.comms.nr = 0;
		PlayerQuest.comms.nrew = 0;
		PlayerQuest.comms.nfail = 0;
		
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards = {};
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required = {};
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].leaderBoards = {};
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].failureConditions = {};
	elseif(mtype == "MSG_REWARD") then
		--local tex, name, nItems, qual, isUse = "", "", 0, 0, "";
		PlayerQuest.comms.nrew = PlayerQuest.comms.nrew + 1;
		
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew] = {};

		local cmsg = msg;
		local ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew].type = string.sub(cmsg, 1, ind-1);

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew].texture = string.sub(cmsg, 1, ind-1);
		
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew].name = string.sub(cmsg, 1, ind-1);

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew].nItems = tonumber(string.sub(cmsg, 1, ind-1));

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew].quality = tonumber(string.sub(cmsg, 1, ind-1));

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew].isUseable = string.sub(cmsg, 1, ind-1);

		cmsg = string.sub(cmsg, ind+1);
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].rewards[PlayerQuest.comms.nrew].link = string.gsub(cmsg, "*", "|");
		
	elseif(mtype == "MSG_FAIL") then
		local ftype = msg; --PlayerQuest.comms.Extract(msg);
		PlayerQuest.comms.nfail = PlayerQuest.comms.nfail + 1;
		
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].failureConditions[PlayerQuest.comms.nfail] = {};
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].failureConditions[PlayerQuest.comms.nfail].type = ftype;
	elseif(mtype == "MSG_REQ") then
--		local parmList = string.split(msg, "@");

		local cmsg = msg;
		local ind = string.find(cmsg, "@");
		PlayerQuest.comms.nr = PlayerQuest.comms.nr + 1;
		
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr] = {};
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].leaderBoards[PlayerQuest.comms.nr] = {};
		
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].type = string.sub(cmsg, 1, ind-1);
		
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].name = string.sub(cmsg, 1, ind-1);

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].fullTime = tonumber(string.sub(cmsg, 1, ind-1));

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].levelRangeLow = tonumber(string.sub(cmsg, 1, ind-1));

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].levelRangeHigh = tonumber(string.sub(cmsg, 1, ind-1));
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].leaderBoard = PlayerQuest.comms.nr;

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].leaderBoards[PlayerQuest.comms.nr].ptype = string.sub(cmsg, 1, ind-1);

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].leaderBoards[PlayerQuest.comms.nr].countMax = tonumber(string.sub(cmsg, 1, ind-1));
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].leaderBoards[PlayerQuest.comms.nr].countNumber = 0;
		
		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].leaderBoards[PlayerQuest.comms.nr].text = string.sub(cmsg, 1, ind-1);
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].leaderBoards[PlayerQuest.comms.nr].countThing = PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].name;

		cmsg = string.sub(cmsg, ind+1);
		ind = string.find(cmsg, "@");
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].link = string.gsub(string.sub(cmsg, 1, ind-1), "*", "|");
		
		cmsg = string.sub(cmsg, ind+1);
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].texture = cmsg;

		--PlayerQuest.comms.OutputMessage("Link: "..PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].link);
		--PlayerQuest.comms.OutputMessage("Texture: "..PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].required[PlayerQuest.comms.nr].texture);

	elseif(mtype == "MSG_QUEST_REPINFO") then
--		local parmList = string.split(msg, "^");
		local cmsg = msg;
		local ind = string.find(cmsg, "@");
		
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].guildRep = string.sub(cmsg, 1, ind-1);
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].guildRepIncrease = tonumber(string.sub(cmsg, ind+1));
	elseif(mtype == "MSG_QUEST_TIMERINFO") then
--		local parmList = string.split(msg, "^");
		local cmsg = msg;
		local ind = string.find(cmsg, "@");
		
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].hasTimer = 1;
		PlayerQuest.comms.DataCache.quests[PlayerQuest.comms.CCQuest].timeLeft = tonumber(string.sub(cmsg, ind+1));
	elseif(mtype == "MSG_PRECACHE_FINISHED") then
		--PlayerQuest.comms.OutputMessage("Testing...");
		HideUIPanel(QuestFrameGreetingPanel);
		QuestFrame:Show();
		TargetByName(fplayer);
		SetPortraitTexture(QuestFramePortrait, "target");
		getglobal("QuestFrameNpcNameText"):SetText(fplayer);
		ShowUIPanel(QuestFrameGreetingPanel);
		--QuestFrameGreetingPanel:Show();
	elseif(mtype == "MSG_CHUNKED_START") then
		PlayerQuest.comms.ChunkList[fplayer] = "";
	elseif(mtype == "MSG_CHUNKED_SEND") then
		PlayerQuest.comms.ChunkList[fplayer] = PlayerQuest.comms.ChunkList[fplayer]..msg;
	elseif(mtype == "MSG_CHUNKED_END") then
		PlayerQuest.comms.CheckMsg(PlayerQuest.comms.ChunkList[fplayer], fplayer);
		PlayerQuest.comms.ChunkList[fplayer] = nil;
	end
end;

