--packages
PlayerQuest.inter = {};

PlayerQuest.inter.Intermediate = nil;

--------------------------------------------------------
-- GetNumQuestItems()								  --
--  Returns: Return the number of required items	  --
--		Not very intuitive naming...				  --
--		ONLY used in the progress frame (When the NPC --
--		Is telling the player his/her progress on	  --
--		the quest.									  --
--------------------------------------------------------
function GetNumQuestItems()
	if(PlayerQuest.inter.Intermediate) then
		return 0;
	end;

	return PlayerQuest.overrides.GetNumQuestItems();
end;

--------------------------------------------------------
-- AcceptQuest()							--
--  Returns: None							--
--  Notes: Accepts the current pendng quest, will need--
--	work to get this complete.				--
-- **UNFINISHED**							--
--------------------------------------------------------
function AcceptQuest()
	local ent, ques = GetNumQuestLogEntries();
	if(ques == 20) then
		PlayerQuest.CompMessage("Your Quest Log is full.");
		DeclineQuest();
		return;
	end;
	if(PlayerQuest.inter.Intermediate) then
		-- Accept the quest by copying it all into the last slot.
		local pdata = PlayerQuest.PlayerData();
		
		pdata.nQuests = pdata.nQuests + 1;
		pdata.quests[pdata.nQuests] = PlayerQuest.inter.Intermediate;

		PlayerQuest.events.CheckCompletedQuest(pdata.nQuests);
		PlayerQuest.events.UpdateOnEvents("QUEST_LOG_UPDATE");

		-- Send the Message to the other player.
		PlayerQuest.comms.Send(PlayerQuest.comms.DataCache.player, "MSG_ACCEPT", PlayerQuest.inter.Intermediate.titleText);
		PlayerQuest.OutputMessage("Quest accepted : "..PlayerQuest.inter.Intermediate.titleText);

		-- Clear the pending quest
		PlayerQuest.inter.Intermediate = nil;
		HideUIPanel(QuestFrame);
			
		-- return the stuff
		return;
	end

	PlayerQuest.overrides.AcceptQuest();
end

----------------------------------------------
-- DeclineQuest()							--
--  Returns: None							--
----------------------------------------------
function DeclineQuest()
	if(PlayerQuest.inter.Intermediate) then
		-- Send the Message to the other player.
		-- PlayerQuest.comms.Send(PlayerQuest.comms.DataCache.player, "MSG_DECLINE_PENDING", PlayerQuest.inter.Intermediate.titleText);
		--  This happens when NOT intended...just don't bother.

		-- Clear the pending quest
		PlayerQuest.inter.Intermediate = nil;
		ShowUIPanel(QuestFrameGreetingPanel);

		-- return the stuff
		return;
	end

	PlayerQuest.overrides.DeclineQuest();
end

function CloseQuest()
	if(PlayerQuest.inter.Intermediate) then
		-- Send the Message to the other player.
		PlayerQuest.comms.Send(PlayerQuest.comms.DataCache.player, "MSG_DECLINE_PENDING", PlayerQuest.inter.Intermediate.titleText);

		-- Clear the pending quest
		PlayerQuest.inter.Intermediate = nil;
		--ShowUIPanel(QuestFrameGreetingPanel);

		-- return the stuff
		return;
	end
	
	PlayerQuest.comms.DataCache = nil;

	PlayerQuest.overrides.CloseQuest();
end;

--------------------------------------------------------
-- GetQuestReward(id)								  --
--  Returns: None									  --
--  Notes: This function...Completes Non-Item-Choice  --
--    Quests, and chooses an item if it is a choice	  --
--    Quest.  Blizzard, you've got some serious fun-  --
--    ction naming issues...						  --
-- **UNFINISHED**									  --
--------------------------------------------------------
function GetQuestReward(id)
	if(PlayerQuest.inter.Intermediate) then
		--Complete me!
		-- This is only a test!!!  This will NOT transfer items or gold!
		-- That will be working in version .7a
		PlayerQuest.comms.Send(PlayerQuest.comms.DataCache.player, "MSG_COMPLETE", PlayerQuest.inter.Intermediate.titleText);
		PlayerQuest.OutputMessage("Quest completed : "..PlayerQuest.inter.Intermediate.titleText);
		
		--remove the quest from the log...
		PlayerQuest.questlog.AbandonQuest = PlayerQuest.inter.ActiveTemp;
		AbandonQuest();
		QuestFrame:Hide();
	end;

	return PlayerQuest.overrides.GetQuestReward(id);
end;

--------------------------------------------------------
-- CompleteQuest()									  --
--  Returns: None									  --
--  Notes: Attempts to complete the quest, or rather  --
--	Will schedule the quest to be completed.		  --
--------------------------------------------------------
function CompleteQuest()
	if(PlayerQuest.inter.Intermediate) then
		HideUIPanel(QuestFrameProgressPanel);
		ShowUIPanel(QuestFrameRewardPanel);
		return;
	end

	return PlayerQuest.overrides.CompleteQuest();
end;

--------------------------------------------------------
-- GetQuestMoneyToGet()								  --
--  Returns: The amount needed to complete the quest  --
--		(Minus the amount already there)			  --
--------------------------------------------------------
function GetQuestMoneyToGet()
	if(PlayerQuest.inter.Intermediate) then
		if (PlayerQuest.inter.Intermediate.requiredMoney == nil) then
			return 0;
		end
		local mon = PlayerQuest.inter.Intermediate.requiredMoney - GetMoney();
		if(mon < 0) then
			mon = 0;
		end
		return mon;
	end

	return PlayerQuest.overrides.GetQuestMoneyToGet();

end;

--------------------------------------------------------
-- GetQuestItemInfo(type, id)						  --
--  Returns: name, texture, numItems, quality,		  --
--		isUseable				  					  --
-- **FINISHED**										  --
--------------------------------------------------------
function PlayerQuest.inter.GetRequiredItem(id)
	local ind = 0;
	for i=1, PlayerQuest.inter.Intermediate.nRequired, 1 do
		if(PlayerQuest.inter.Intermediate.required[i].type == "item") then
			ind = ind + 1;
			if(ind == id) then
				return i;
			end
		end
	end
end

function PlayerQuest.inter.GetRewardItem(id)
	local ind=0;
	for i=1, PlayerQuest.inter.Intermediate.nRewards, 1 do
		if(PlayerQuest.inter.Intermediate.rewards[i].type ~= "money") then
			ind = ind + 1;
			if(ind == id) then
				return i;
			end;
		end
	end
end

function GetQuestItemInfo(itype, id)
	if(PlayerQuest.inter.Intermediate) then
		if(itype == "required") then
			local nid = PlayerQuest.inter.GetRequiredItem(id);
			return PlayerQuest.inter.Intermediate.required[nid].name,
				PlayerQuest.inter.Intermediate.required[nid].texture,
				PlayerQuest.inter.Intermediate.required[nid].numItems,
				PlayerQuest.inter.Intermediate.required[nid].quality,
				PlayerQuest.inter.Intermediate.required[nid].isUseable;
		elseif(itype == "choice") then	
			return PlayerQuest.inter.Intermediate.choices[id].name,
				PlayerQuest.inter.Intermediate.choices[id].texture,
				PlayerQuest.inter.Intermediate.choices[id].numItems,
				PlayerQuest.inter.Intermediate.choices[id].quality,
				PlayerQuest.inter.Intermediate.choices[id].isUseable;
		elseif(itype == "reward") then	
			local nid = PlayerQuest.inter.GetRewardItem(id);
			return PlayerQuest.inter.Intermediate.rewards[nid].name,
				PlayerQuest.inter.Intermediate.rewards[nid].texture,
				PlayerQuest.inter.Intermediate.rewards[nid].numItems,
				PlayerQuest.inter.Intermediate.rewards[nid].quality,
				PlayerQuest.inter.Intermediate.rewards[nid].isUseable;
		end
	end

	return PlayerQuest.overrides.GetQuestItemInfo(itype, id);
end;

--------------------------------------------------------
-- GetNumActiveQuests()								  --
--  Returns: Number of active quests from the current --
--	quest giver.									  --
--------------------------------------------------------
function GetNumActiveQuests()
	if(PlayerQuest.Ready()) then
		local pdata = PlayerQuest.PlayerData();
		if(PlayerQuest.comms.DataCache) then
			local count = 0;
			-- ok, check to see if the player is the finisher of any active quests...
			for i=1, pdata.nQuests, 1 do
				--PlayerQuest.OutputMessage(
				if(pdata.quests[i].finishPlayers[1] == PlayerQuest.comms.DataCache.player) then
					count = count + 1;
				end
			end
			
			--PlayerQuest.OutputMessage("Count: "..count);
			return count;
		end
	end

	return PlayerQuest.overrides.GetNumActiveQuests();
end;

--------------------------------------------------------
-- GetNumAvailableQuests()							  --
--  Returns: the number of available quests			  --
--------------------------------------------------------
function PlayerQuest.inter.CheckDoing(qid, fpl)
	local i;
	local pdata = PlayerQuest.PlayerData();
	for i=1, pdata.nQuests, 1 do
		if(pdata.quests[i].finishPlayers[1] == fpl) then
			if(pdata.quests[i].titleText == PlayerQuest.comms.DataCache.quests[qid].titleText) then
				return 1;
			end
		end
	end
	
	return nil
end

function PlayerQuest.inter.CountAvail()
	local i, count;
	count = 0;
	for i=1, PlayerQuest.comms.DataCache.nQuests, 1 do
		if(not PlayerQuest.inter.CheckDoing(i, PlayerQuest.comms.DataCache.player)) then
			if(not PlayerQuest.inter.CheckDoing(i, PlayerQuest.comms.DataCache.player)) then
				count = count + 1;
			end
		end
	end
	
	return count;
end;

function PlayerQuest.inter.GetAvailID(qid)
	local i, count;
	count = 0;
	for i=1, PlayerQuest.comms.DataCache.nQuests, 1 do
		if(not PlayerQuest.inter.CheckDoing(i, PlayerQuest.comms.DataCache.player)) then
			if(not PlayerQuest.inter.CheckDoing(i, PlayerQuest.comms.DataCache.player)) then
				count = count + 1;
				if(count == qid) then
					return i;
				end
			end
		end
	end
	
	return nil;
end

function GetNumAvailableQuests()
	if(PlayerQuest.Ready()) then
		if(PlayerQuest.comms.DataCache) then
			return PlayerQuest.inter.CountAvail();
		end
	end

	return PlayerQuest.overrides.GetNumAvailableQuests();
end;

function GetAvailableTitle(i)
	if(PlayerQuest.Ready()) then
		if(PlayerQuest.comms.DataCache) then
			return PlayerQuest.comms.DataCache.quests[PlayerQuest.inter.GetAvailID(i)].titleText;
		end
	end

	return PlayerQuest.overrides.GetAvailableTitle(i);
end;

--------------------------------------------------------
-- GetActiveTitle()									  --
--  Returns: 										  --
--------------------------------------------------------
function GetActiveTitle(id)
	if(PlayerQuest.Ready()) then
		local pdata = PlayerQuest.PlayerData();
		if(PlayerQuest.comms.DataCache) then
			local count = 0;
			-- ok, check to see if the player is the finisher of any active quests...
			for i=1, pdata.nQuests, 1 do
				if(pdata.quests[i].finishPlayers[1] == PlayerQuest.comms.DataCache.player) then
					count = count + 1;
					if(count == id) then
						return pdata.quests[i].titleText;
					end
				end
			end
			
			return nil;
		end
	end

	return PlayerQuest.overrides.GetActiveTitle(id);
end;

--------------------------------------------------------
-- GetGreetingText()								  --
--  Returns: The greeting text of the current target  --
--	This should be figured out soon					  --
--------------------------------------------------------
function GetGreetingText()
	if(PlayerQuest.Ready()) then
		if(PlayerQuest.comms.DataCache) then
			return PlayerQuest.comms.DataCache.greetingText;
		end
	end

	return PlayerQuest.overrides.GetGreetingText();	
end

--------------------------------------------------------
-- GetNumQuestRewards;
--  Returns: 
--------------------------------------------------------
function GetNumQuestRewards()
	if(PlayerQuest.inter.Intermediate) then
		--PlayerQuest.OutputMessage("Number of rewards: "..PlayerQuest.inter.Intermediate.nRewards);
		local ind=0;
		for i=1, PlayerQuest.inter.Intermediate.nRewards, 1 do
			if(PlayerQuest.inter.Intermediate.rewards[i].type ~= "money") then
				ind = ind + 1;
			end
		end
		
		return ind;
	end
	return PlayerQuest.overrides.GetNumQuestRewards();
end;

--------------------------------------------------------
-- GetNumQuestChoices;
--  Returns: 
--------------------------------------------------------
function GetNumQuestChoices()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.nChoices;
	end
	
	return PlayerQuest.overrides.GetNumQuestChoices();
end;

--------------------------------------------------------
-- GetRewardSpell;
--  Returns: 
--------------------------------------------------------
function GetRewardSpell()
	if(PlayerQuest.inter.Intermediate) then
		return nil;
	end
	
	return PlayerQuest.overrides.GetRewardSpell();
end;
--------------------------------------------------------
-- GetRewardMoney;
--  Returns: 
--------------------------------------------------------
function GetRewardMoney()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.rewardMoney;
	end
	
	return PlayerQuest.overrides.GetRewardMoney();
end;

function SelectActiveQuest(id)
	if(PlayerQuest.comms.DataCache) then
		local count = 0;
		local pdata = PlayerQuest.PlayerData();
		-- ok, check to see if the player is the finisher of any active quests...
		for i=1, pdata.nQuests, 1 do
			if(pdata.quests[i].finishPlayers[1] == PlayerQuest.comms.DataCache.player) then
				count = count + 1;
				if(count == id) then
					PlayerQuest.inter.Intermediate = pdata.quests[i];
					PlayerQuest.inter.ActiveTemp = i;
		
					-- Show the window...
					HideUIPanel(QuestFrameGreetingPanel);
--					if(pdata.quests[i].isComplete) then
--						ShowUIPanel(QuestFrameRewardPanel);
--					else
						ShowUIPanel(QuestFrameProgressPanel);
--					end
					return;
				end
			end
		end
	end
	
	return PlayerQuest.overrides.SelectActiveQuest(id);
end;

function SelectAvailableQuest(id)
	if(PlayerQuest.comms.DataCache) then
		PlayerQuest.inter.Intermediate = PlayerQuest.comms.DataCache.quests[PlayerQuest.inter.GetAvailID(id)];
		
		-- Show the window...
		HideUIPanel(QuestFrameGreetingPanel);
		ShowUIPanel(QuestFrameDetailPanel);
		return;
	end;
	
	return PlayerQuest.overrides.SelectAvailableQuest(id);
end;

function GetTitleText()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.titleText;
	end;
	
	return PlayerQuest.overrides.GetTitleText();
end;

function GetQuestText()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.Description;
	end;
	
	return PlayerQuest.overrides.GetQuestText();
end;

function GetObjectiveText()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.Objectives;
	end;
	
	return PlayerQuest.overrides.GetObjectiveText();
end;

function GetProgressText()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.ProgressText;
	end;
	
	return PlayerQuest.overrides.GetProgressText();
end;

function GetRewardText()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.CompleteText;
	end;
	
	return PlayerQuest.overrides.GetRewardText();
end;

function IsQuestCompletable()
	if(PlayerQuest.inter.Intermediate) then
		return PlayerQuest.inter.Intermediate.isComplete;
	end;
	
	return PlayerQuest.overrides.IsQuestCompletable();
end