
--packages
PlayerQuest.wizard = {};
PlayerQuest.wizard.Working = nil;
PlayerQuest.wizard.Exist = nil;



--			PAGE 1
------------------------------------------------------------


function PlayerQuest.wizard.Finalize()
	if(not PlayerQuest.wizard.Exist) then
		local pdata = PlayerQuest.PlayerData();
		pdata.nCreatedQuests = pdata.nCreatedQuests + 1;
		pdata.createdQuests[pdata.nCreatedQuests] = PlayerQuest.wizard.Working;
		
		PlayerQuest.CompMessage("Quest Created : "..PlayerQuest.wizard.Working.titleText);
	end;
	
	HideUIPanel(PQFrame);
end;

function QuestFrame_OnHide()
	PlayerQuest.wizard.DataCache = nil;
	PlayerQuest.wizard.Intermediate = nil;
	PickupContainerItem = PlayerQuest.overrides.PickupItem;
	
	PlayerQuest.overrides.QuestFrame_OnHide();
end



function PlayerQuest.OnShow()
end

function PlayerQuest.OnHide()
	--Hide the panels...
	HideUIPanel(QuestFrameWizardPanel1);
	HideUIPanel(QuestFrameWizardPanel2);
	HideUIPanel(QuestFrameWizardPanel3);
	HideUIPanel(QuestFrameWizardPanel4);
	HideUIPanel(QuestFrameWizardPanel4a);
	HideUIPanel(QuestFrameWizardPanel5);
	--HideUIPanel(QuestFrameWizardPanel5a);
	HideUIPanel(QuestFrameWizardPanel6);
	HideUIPanel(QuestFrameWizardPanel7);
	--HideUIPanel(QuestFrameWizardPanel8);
	--cancel the working quest
	PlayerQuest.wizard.Working = nil;
	
	--PQ_WizO_QuestFrame_OnHide();
end

function PQ_WP1_OnShow()
	if(PlayerQuest.wizard.Working) then
		-- already working on a quest, load the data
		PlayerQuest.wizard.Exist = 1;
	else
		PlayerQuest.wizard.Exist = nil;
		--create a new quest to get ready.
		PlayerQuest.wizard.Working = {};
		
		--make a guess at the level :)
		PlayerQuest.wizard.Working.level = UnitLevel("player");
	end

	-- Check for empty values...	
	if(PlayerQuest.wizard.Working.titleText == nil) then
		PlayerQuest.wizard.Working.titleText = PQ_PAGE1ENTERTITLE;
	end;
	if(PlayerQuest.wizard.Working.finishPlayers == nil) then
		PlayerQuest.wizard.Working.finishPlayers = {};
		PlayerQuest.wizard.Working.finishPlayers[1] = PlayerQuest.ShortPlayerName;
		PlayerQuest.wizard.Working.nFinishPlayers = 1;
	end;
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE1);
	getglobal("QuestFrameWP1InstructionsText"):SetText(PQ_PAGE1TEXT);
	
	getglobal("PQTitleWideEditBox"):SetText(PlayerQuest.wizard.Working.titleText);
	getglobal("PQFinishWideEditBox"):SetText(PlayerQuest.wizard.Working.finishPlayers[1]);
end;
	
function PQ_WP1_Next_OnClick()
	PlayerQuest.wizard.Working.titleText = getglobal("PQTitleWideEditBox"):GetText();
	PlayerQuest.wizard.Working.finishPlayers[1] = getglobal("PQFinishWideEditBox"):GetText();
	-- Copy title..

	HideUIPanel(QuestFrameWizardPanel1);
	ShowUIPanel(QuestFrameWizardPanel2);
end;

function PQ_WP2_OnShow()
	if(PlayerQuest.wizard.Working.Description == nil) then
		PlayerQuest.wizard.Working.Description = PQ_PAGE1ENTERDESC;
	end;
	
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE2);
	
	PlayerQuestWizardDescriptionBox:SetText(string.gsub(PlayerQuest.wizard.Working.Description, "<br>", "\n"));
end;

function PQ_WP2_Prev_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.Description = string.gsub(PlayerQuestWizardDescriptionBox:GetText(), "\n", "<br>");
	
	HideUIPanel(QuestFrameWizardPanel2);
	ShowUIPanel(QuestFrameWizardPanel1);
end;

function PQ_WP2_Next_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.Description = string.gsub(PlayerQuestWizardDescriptionBox:GetText(), "\n", "<br>");
	
	HideUIPanel(QuestFrameWizardPanel2);
	ShowUIPanel(QuestFrameWizardPanel3);
end;

function PQ_WP3_OnShow()
	if(PlayerQuest.wizard.Working.Objectives == nil) then
		PlayerQuest.wizard.Working.Objectives = "<Enter Objectives Text>";
	end;
	
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE3);
	
	PlayerQuestWizardObjBox:SetText(string.gsub(PlayerQuest.wizard.Working.Objectives, "<br>", "\n"));
end;

function PQ_WP3_Prev_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.Objectives = string.gsub(PlayerQuestWizardObjBox:GetText(), "\n", "<br>");
	
	HideUIPanel(QuestFrameWizardPanel3);
	ShowUIPanel(QuestFrameWizardPanel2);
end;

function PQ_WP3_Next_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.Objectives = string.gsub(PlayerQuestWizardObjBox:GetText(), "\n", "<br>");
	
	HideUIPanel(QuestFrameWizardPanel3);
	ShowUIPanel(QuestFrameWizardPanel4);
end;

function PQ_WP4_OnShow()
	if(PlayerQuest.wizard.Working.nRequired == nil) then
		PlayerQuest.wizard.Working.nRequired = 0;
		PlayerQuest.wizard.Working.required = {};
	end;
	
	if(PlayerQuest.wizard.Working.nLeaderBoards == nil) then
		PlayerQuest.wizard.Working.nLeaderBoards = 0;
		PlayerQuest.wizard.Working.leaderBoards = {};
	end;

	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE4);
	
	for i = 1, 10, 1 do
		if(PlayerQuest.wizard.Working.required[i] == nil) then
			getglobal("QuestReqButton"..i):SetText("<Click to add objective>");
			if((PlayerQuest.wizard.Working.required[i-1] == nil) and (i ~= 1)) then
				getglobal("QuestReqButton"..i):Hide();
			else
				getglobal("QuestReqButton"..i):Show();
			end
		else
			getglobal("QuestReqButton"..i):SetText(PQ_Req_Print( i ));
			-- set it to the standard leaderboard format for that item
		end;
	end;
end;

function PQ_Wiz_ReqClick(ind)
	PlayerQuest.wizard.WorkingReq = ind;
	
	--Debug...
	PlayerQuest.OutputMessage("Clicked objective "..ind);
	--Show the editing panel...
	HideUIPanel(QuestFrameWizardPanel4);
	PlayerQuest.wizard.ConfFrame_Status = "Objective";
	ShowUIPanel(QuestFrameWizardPanel4a);	
end;

function PQ_WP4_Prev_OnClick()	
	-- consolidate the requirements...
	
	HideUIPanel(QuestFrameWizardPanel4);
	ShowUIPanel(QuestFrameWizardPanel3);
end;

function PQ_WP4_Next_OnClick()	
	-- consolidate the requirements...
	
	HideUIPanel(QuestFrameWizardPanel4);
	ShowUIPanel(QuestFrameWizardPanel5);
end;

function PQ_Init_Reqs()
	-- add conditional here...
end

function PQ_WP4a_OnShow()
	PickupContainerItem = PlayerQuest.items.PickupContainerItem;
	if(PlayerQuest.wizard.ConfFrame_Status == "Objective") then
		getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE4a..PlayerQuest.wizard.WorkingReq);
		PlayerQuest.wizard.List_Type_Text = PQ_Req_Type_Text;
--		PQ_ConfFrame_Init = PQ_InitReqs;
		PlayerQuest.wizard.ShowTypeFrame = PQ_Show_Type_Frame;
		PlayerQuest.wizard.SaveFunc = PQ_Req_Type_SaveFunc;
		PlayerQuest.wizard.LoadFunc = PQ_Req_Type_LoadFunc;
		PlayerQuest.wizard.WItem = PlayerQuest.wizard.Working.required;
		PlayerQuest.wizard.WItemCount = "nRequired";
		PlayerQuest.wizard.WItem2 = PlayerQuest.wizard.Working.leaderBoards;
		PlayerQuest.wizard.WItem2Count = "nLeaderBoards";
		PlayerQuest.wizard.Types = PQ_Req_Types;
		PlayerQuest.wizard.GoBackFrame = QuestFrameWizardPanel4;
		PlayerQuest.wizard.NUM_TYPES = PQ_NUM_REQ_TYPES;
	elseif(PlayerQuest.wizard.ConfFrame_Status == "FailCondition") then
		getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE5a..PlayerQuest.wizard.WorkingReq);
		PlayerQuest.wizard.List_Type_Text = PQ_FObj_Type_Text;
--		PQ_ConfFrame_Init = PQ_InitReqs;
		PlayerQuest.wizard.ShowTypeFrame = PQ_FObj_Show_Type_Frame;
		PlayerQuest.wizard.SaveFunc = PQ_FObj_Type_SaveFunc;
		PlayerQuest.wizard.LoadFunc = PQ_FObj_Type_LoadFunc;
		PlayerQuest.wizard.WItem = PlayerQuest.wizard.Working.failureConditions;
		PlayerQuest.wizard.WItemCount = "nFailureConditions";
		PlayerQuest.wizard.WItem2 = nil;
		PlayerQuest.wizard.WItem2Count = nil;
		PlayerQuest.wizard.Types = PQ_FObj_Types;
		PlayerQuest.wizard.GoBackFrame = QuestFrameWizardPanel5;
		PlayerQuest.wizard.NUM_TYPES = PQ_NUM_FOBJ_TYPES;
	elseif(PlayerQuest.wizard.ConfFrame_Status == "Reward") then
		getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE8a..PlayerQuest.wizard.WorkingReq);
		PlayerQuest.wizard.List_Type_Text = PQ_Rew_Type_Text;
--		PQ_ConfFrame_Init = PQ_InitReqs;
		PlayerQuest.wizard.ShowTypeFrame = PQ_Rew_Show_Type_Frame;
		PlayerQuest.wizard.SaveFunc = PQ_Rew_Type_SaveFunc;
		PlayerQuest.wizard.LoadFunc = PQ_Rew_Type_LoadFunc;
		PlayerQuest.wizard.WItem = PlayerQuest.wizard.Working.rewards;
		PlayerQuest.wizard.WItemCount = "nRewards";
		PlayerQuest.wizard.WItem2 = nil;
		PlayerQuest.wizard.WItem2Count = nil;
		PlayerQuest.wizard.Types = PQ_Rew_Types;
		PlayerQuest.wizard.GoBackFrame = QuestFrameWizardPanel8;
		PlayerQuest.wizard.NUM_TYPES = PQ_NUM_REW_TYPES;
	elseif(PlayerQuest.wizard.ConfFrame_Status == "Restriction") then
		getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE9a..PlayerQuest.wizard.WorkingReq);
		PlayerQuest.wizard.List_Type_Text = PQ_Restrict_Type_Text;
--		PQ_ConfFrame_Init =PQ_InitReqs;
		PlayerQuest.wizard.ShowTypeFrame = PQ_Restrict_Show_Type_Frame;
		PlayerQuest.wizard.SaveFunc = PQ_Restrict_Type_SaveFunc;
		PlayerQuest.wizard.LoadFunc = PQ_Restrict_Type_LoadFunc;
		PlayerQuest.wizard.WItem = PlayerQuest.wizard.Working.restricts;
		PlayerQuest.wizard.WItemCount = "nRestricts";
		PlayerQuest.wizard.WItem2 = nil;
		PlayerQuest.wizard.WItem2Count = nil;
		PlayerQuest.wizard.Types = PQ_Restrict_Types;
		PlayerQuest.wizard.GoBackFrame = QuestFrameWizardPanel9;
		PlayerQuest.wizard.NUM_TYPES = PQ_NUM_RESTRICT_TYPES;
	end	
	
	PQ_SELECT_TYPE_FRAME:Hide();
	PQ_UNIMP_TYPE_FRAME:Hide();
	PQ_ENTERAREA_TYPE_FRAME:Hide();
	PQ_NOSETTINGS_TYPE_FRAME:Hide();
	PQ_MISC_TYPE_FRAME:Hide();
	
	for i=1, 15, 1 do
		getglobal("ReqList"..i):SetText("");
		getglobal("ReqList"..i):Hide();
	end
	
	for i=1,PlayerQuest.wizard.NUM_TYPES,1 do
		getglobal("ReqList"..i):SetText(PlayerQuest.wizard.List_Type_Text[i]);
		getglobal("ReqList"..i):Show();
	end;
	
	if(PlayerQuest.wizard.WItem[PlayerQuest.wizard.WorkingReq]) then
		local rt = PlayerQuest.wizard.Types[PlayerQuest.wizard.WItem[PlayerQuest.wizard.WorkingReq].type];

		RequirementTypeDDListMenuText:SetText(PlayerQuest.wizard.List_Type_Text[rt]);
		PlayerQuest.wizard.ShowTypeFrame(rt);
		PlayerQuest.wizard.ReqTypeID = rt;

		local func = PlayerQuest.wizard.LoadFunc[rt];
		if(func) then
			func(PlayerQuest.wizard.WorkingReq);
		end;
	else
		RequirementTypeDDListMenuText:SetText(PlayerQuest.wizard.List_Type_Text[0]);
		PlayerQuest.wizard.ShowTypeFrame(0);
		PlayerQuest.wizard.ReqTypeID = 0;
	end;

end;

function PQ_ShowReqTypeList()
	RequirementTypeList:Show();
end

function PQ_DropDownOnClick(id)
	RequirementTypeDDListMenuText:SetText(PlayerQuest.wizard.List_Type_Text[id]);
	PlayerQuest.wizard.ShowTypeFrame(id);
	RequirementTypeList:Hide();
	PlayerQuest.wizard.ReqTypeID = id;
end

function PQ_WP4a_Prev_OnClick()	
	PickupContainerItem = PlayerQuest.overrides.PickupItem;
	HideUIPanel(QuestFrameWizardPanel4a);
	PlayerQuest.wizard.ConfFrame_Status = nil;
	ShowUIPanel(PlayerQuest.wizard.GoBackFrame);
end;

function PQ_WP4a_Next_OnClick()	
	PickupContainerItem = PlayerQuest.overrides.PickupItem;
	if(PlayerQuest.wizard.SaveFunc[PlayerQuest.wizard.ReqTypeID]) then
		PlayerQuest.wizard.SaveFunc[PlayerQuest.wizard.ReqTypeID](PlayerQuest.wizard.WorkingReq);
	else
		PlayerQuest.wizard.SaveFunc[0](PlayerQuest.wizard.WorkingReq);
	end
	-- consolidate the requirements...
	for i=1, 20, 1 do
		for j=i, 1, -1 do
			if(PlayerQuest.wizard.WItem[j] == nil) then
				PlayerQuest.wizard.WItem[j] = PlayerQuest.wizard.WItem[j+1];
				PlayerQuest.wizard.WItem[j+1] = nil;

				if(PlayerQuest.wizard.WItem2) then
					PlayerQuest.wizard.WItem2[j] = PlayerQuest.wizard.WItem2[j+1];
					PlayerQuest.wizard.WItem2[j+1] = nil;
				end
			end
		end		
	end;
	local found = nil;
	for k=1, 20, 1 do
		if((PlayerQuest.wizard.WItem[k] == nil) and (found == nil)) then
			PlayerQuest.wizard.Working[PlayerQuest.wizard.WItemCount] = k-1;
			if(PlayerQuest.wizard.WItem2) then
				PlayerQuest.wizard.Working[PlayerQuest.wizard.WItem2Count] = k-1;
			end
			found = 1;
--			PlayerQuest.OutputMessage("Item count set to : "..PlayerQuest.wizard.Working[PlayerQuest.wizard.WItemCount]);
		end
	end
	
	HideUIPanel(QuestFrameWizardPanel4a);
	PlayerQuest.wizard.ConfFrame_Status = nil;
	ShowUIPanel(PlayerQuest.wizard.GoBackFrame);
end;

function PQ_WP5_OnShow()
	if(PlayerQuest.wizard.Working.failureConditions == nil) then
		PlayerQuest.wizard.Working.nFailureConditions = 0;
		PlayerQuest.wizard.Working.failureConditions = {};
	end;
	
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE5);
	
	--clear the time left
	PlayerQuest.wizard.Working.timeLeft = 0;
	
	for i = 1, 10, 1 do
		if(PlayerQuest.wizard.Working.failureConditions[i] == nil) then
			getglobal("QuestFObjButton"..i):SetText("<Click to add condition>");
			if((PlayerQuest.wizard.Working.failureConditions[i-1] == nil) and (i ~= 1)) then
				getglobal("QuestFObjButton"..i):Hide();
			else
				getglobal("QuestFObjButton"..i):Show();
			end
		else
			getglobal("QuestFObjButton"..i):SetText(PQ_FObj_Print( i ));
				
			--check for the time restriction...
			if(PlayerQuest.wizard.Working.failureConditions[i].type == "time") then
				PlayerQuest.wizard.Working.timeLeft = PlayerQuest.wizard.Working.timeLeft + PlayerQuest.wizard.Working.failureConditions[i].failTime;
			end
		end;
	end;
	
	if(PlayerQuest.wizard.Working.timeLeft == 0) then
		PlayerQuest.wizard.Working.hasTimer = nil;
	else
		PlayerQuest.wizard.Working.hasTimer = 1;
	end
end;

function PQ_Wiz_FObjClick(ind)
	PlayerQuest.wizard.WorkingReq = ind;
	
	--Debug...
	PlayerQuest.OutputMessage("Clicked condition "..ind);
	--Show the editing panel...
	HideUIPanel(QuestFrameWizardPanel5);

	PlayerQuest.wizard.ConfFrame_Status = "FailCondition";
	ShowUIPanel(QuestFrameWizardPanel4a);	
end;

function PQ_WP5_Prev_OnClick()	
	-- consolidate the requirements...
	
	HideUIPanel(QuestFrameWizardPanel5);
	ShowUIPanel(QuestFrameWizardPanel4);
end;

function PQ_WP5_Next_OnClick()	
	-- consolidate the requirements...
	
	HideUIPanel(QuestFrameWizardPanel5);
	ShowUIPanel(QuestFrameWizardPanel6);
end;

function PQ_WP6_OnShow()
	if(PlayerQuest.wizard.Working.ProgressText == nil) then
		PlayerQuest.wizard.Working.ProgressText = "<Enter Progress Text>";
	end;
	
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE6);
	
	PlayerQuestWizardProgBox:SetText(string.gsub(PlayerQuest.wizard.Working.ProgressText, "<br>", "\n"));
end;

function PQ_WP6_Prev_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.ProgressText = string.gsub(PlayerQuestWizardProgBox:GetText(), "\n", "<br>");
	
	HideUIPanel(QuestFrameWizardPanel6);
	ShowUIPanel(QuestFrameWizardPanel5);
end;

function PQ_WP6_Next_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.ProgressText = PlayerQuestWizardProgBox:GetText();
	
	HideUIPanel(QuestFrameWizardPanel6);
	ShowUIPanel(QuestFrameWizardPanel7);
end;

function PQ_WP7_OnShow()
	if(PlayerQuest.wizard.Working.CompleteText == nil) then
		PlayerQuest.wizard.Working.CompleteText = "<Enter Completion Text>";
	end;
	
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE7);
	
	PlayerQuestWizardCompBox:SetText(string.gsub(PlayerQuest.wizard.Working.CompleteText, "<br>", "\n"));
end;

function PQ_WP7_Prev_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.CompleteText = string.gsub(PlayerQuestWizardCompBox:GetText(), "\n", "<br>");
	
	HideUIPanel(QuestFrameWizardPanel7);
	ShowUIPanel(QuestFrameWizardPanel6);
end;

function PQ_WP7_Next_OnClick()
	-- Copy description
	PlayerQuest.wizard.Working.CompleteText = string.gsub(PlayerQuestWizardCompBox:GetText(), "\n", "<br>");
	
	HideUIPanel(QuestFrameWizardPanel7);
	ShowUIPanel(QuestFrameWizardPanel8);
end;

function PQ_WP8_OnShow()
	if(PlayerQuest.wizard.Working.rewards == nil) then
		PlayerQuest.wizard.Working.nRewards = 0;
		PlayerQuest.wizard.Working.rewards = {};
	end;
	
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE8);
	
	for i = 1, 10, 1 do
		if(PlayerQuest.wizard.Working.rewards[i] == nil) then
			getglobal("QuestRewButton"..i):SetText("<Click to add reward>");
			if((PlayerQuest.wizard.Working.rewards[i-1] == nil) and (i ~= 1)) then
				getglobal("QuestRewButton"..i):Hide();
			else
				getglobal("QuestRewButton"..i):Show();
			end
		else
			getglobal("QuestRewButton"..i):SetText(PQ_Rew_Print( i ));
			-- set it to the standard leaderboard format for that item
		end;
	end;
end;

function PQ_Wiz_RewClick(ind)
	PlayerQuest.wizard.WorkingReq = ind;
	
	--Debug...
--	PlayerQuest.OutputMessage("Clicked condition "..ind);
	--Show the editing panel...
	HideUIPanel(QuestFrameWizardPanel8);

	PlayerQuest.wizard.ConfFrame_Status = "Reward";
	ShowUIPanel(QuestFrameWizardPanel4a);	
end;

function PQ_WP8_Prev_OnClick()	
	HideUIPanel(QuestFrameWizardPanel8);
	ShowUIPanel(QuestFrameWizardPanel7);
end;

function PQ_WP8_Next_OnClick()	
	HideUIPanel(QuestFrameWizardPanel8);
	ShowUIPanel(QuestFrameWizardPanel9);
	
	--PQ_Finalize();
end;


function PQ_WP9_OnShow()
	if(PlayerQuest.wizard.Working.restricts == nil) then
		PlayerQuest.wizard.Working.nRestricts = 0;
		PlayerQuest.wizard.Working.restricts = {};
	end;
	
	getglobal("PlayerQuestFrameNpcNameText"):SetText(PQ_PAGE9);
	
	for i = 1, 10, 1 do
		if(PlayerQuest.wizard.Working.restricts[i] == nil) then
			getglobal("QuestRestrictButton"..i):SetText("<Click to add restriction>");
			if((PlayerQuest.wizard.Working.restricts[i-1] == nil) and (i ~= 1)) then
				getglobal("QuestRestrictButton"..i):Hide();
			else
				getglobal("QuestRestrictButton"..i):Show();
			end
		else
			getglobal("QuestRestrictButton"..i):SetText(PQ_Restrict_Print( i ));
			-- set it to the standard leaderboard format for that item
		end;
	end;
	
end;

function PQ_Wiz_RestrictClick(ind)
	PlayerQuest.wizard.WorkingReq = ind;
	
	--Debug...
--	PlayerQuest.OutputMessage("Clicked condition "..ind);
	--Show the editing panel...
	HideUIPanel(QuestFrameWizardPanel9);

	PlayerQuest.wizard.ConfFrame_Status = "Restriction";
	ShowUIPanel(QuestFrameWizardPanel4a);	
end;

function PQ_WP9_Prev_OnClick()	
	HideUIPanel(QuestFrameWizardPanel9);
	ShowUIPanel(QuestFrameWizardPanel8);
end;

function PQ_WP9_Next_OnClick()	
	HideUIPanel(QuestFrameWizardPanel9);
	--ShowUIPanel(QuestFrameWizardPanel9);
	
	PlayerQuest.wizard.Finalize();
end;
